unit u40Hra;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus;

type
  TfoHra = class(TForm)
    ouHrac: TLabel;
    paHra: TPanel;
    ouBody1: TLabel;
    ouBody2: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    MainMenu1: TMainMenu;
    Hra1: TMenuItem;
    meKonec: TMenuItem;
    meNova: TMenuItem;
    N1: TMenuItem;
    procedure SirkaMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ShowHrac;
    procedure ShowBody;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure meKonecClick(Sender: TObject);
    procedure meNovaClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    procedure ZaberCtverec(const IndexCtverce: integer);
    function GetX0: integer;
    function GetY0: integer;
    function GetIndexSirky(const x, y: integer): integer;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  foHra: TfoHra;

implementation

uses u40Data, u40TopTen;

{$R *.DFM}

var ZabralCtverec: boolean;
    UkoncitProgram: boolean = true;

procedure TfoHra.ShowHrac;
begin
   if CisloHrace = 1 then begin
      ouHrac.Caption := 'Hraje zelen hr';
      ouHrac.Color := Barva1;
   end;
   if CisloHrace = 2 then begin
      ouHrac.Caption := 'Hraje erven hr';
      ouHrac.Color := Barva2;
   end;
end;

function JeSirka(const IndexSirky: integer): boolean;
begin
   Result := false;
   if IndexSirky < 0 then exit;
   if IndexSirky > High(Sirky) then exit;
   if Sirky[IndexSirky].Brush.Color <> Barva0 then Result := true;
end;


procedure TfoHra.ShowBody;
begin
   ouBody1.Color := Barva1;
   ouBody2.Color := Barva2;
   ouBody1.Caption := 'Body: ' + IntToStr(Body1);
   ouBody2.Caption := 'Body: ' + IntToStr(Body2);
end;


procedure TfoHra.ZaberCtverec(const IndexCtverce: integer);
begin
   if IndexCtverce < 0 then exit;
   if IndexCtverce > High(Ctverce) then exit;
   with Ctverce[IndexCtverce] as tShape do
      if not Visible then begin
         if CisloHrace = 1 then begin
            Brush.Color := Barva1;
            Inc(Body1);
            ShowBody;
         end;
         if CisloHrace = 2 then begin
            Brush.Color := Barva2;
            Inc(Body2);
            ShowBody;
         end;
         Visible := true;
         ZabralCtverec := true;
      end;
end;


function GetJmeno: string;
begin
   Result := InputBox('Top-ten', 'Vae jmno','');
end;


procedure TfoHra.SirkaMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var MujIndex, MujSloupec, MujRadek: integer;
    a, b, c: integer;
    Jmeno: string;
    f: textfile;
    Body: integer;
begin
   // nemohu poloit sirku na msto, kde u sirka je
   if (Sender as tShape).Brush.Color <> Barva0 then exit;

   // polom sirku
   if CisloHrace = 1 then (Sender as tShape).Brush.Color := Barva1;
   if CisloHrace = 2 then (Sender as tShape).Brush.Color := Barva2;

   // test zabranho tverce
   ZabralCtverec := false;
   MujIndex := (Sender as tShape).Tag;
   if MujIndex < Length(Sirky) div 2 then begin
      // sirka naleato
      MujSloupec := MujIndex mod N;
      MujRadek   := MujIndex div N;
      // test tverce nademnou
      a := MujIndex - N;
      b := Length(Sirky) div 2 + (MujRadek-1) * (N+1) +  MujSloupec;
      c := Length(Sirky) div 2 + (MujRadek-1) * (N+1) + (MujSloupec+1);
      if JeSirka(a) and JeSirka(b) and JeSirka(c) then
         ZaberCtverec((MujRadek-1) * N + MujSloupec);
      // test tverce podemnou
      a := MujIndex + N;
      b := Length(Sirky) div 2 + MujRadek * (N+1) +  MujSloupec;
      c := Length(Sirky) div 2 + MujRadek * (N+1) + (MujSloupec+1);
      if JeSirka(a) and JeSirka(b) and JeSirka(c) then
         ZaberCtverec(MujRadek * N + MujSloupec);
   end
   else begin
      // sirka nastojato
      MujSloupec := (MujIndex - Length(Sirky) div 2) mod (N+1);
      MujRadek   := (MujIndex - Length(Sirky) div 2) div (N+1);
      // test tverce vlevo
      a := MujIndex - 1;
      b :=  MujRadek    * N + MujSloupec - 1;
      c := (MujRadek+1) * N + MujSloupec - 1;
      if JeSirka(a) and JeSirka(b) and JeSirka(c) then
         ZaberCtverec(MujRadek * N + MujSloupec-1);
      // test tverce vpravo
      a := MujIndex + 1;
      b :=  MujRadek    * N + MujSloupec;
      c := (MujRadek+1) * N + MujSloupec;
      if JeSirka(a) and JeSirka(b) and JeSirka(c) then
         ZaberCtverec(MujRadek * N + MujSloupec);
   end;

   // neznme u vtze?
   if Body1 + Body2 >= Length(Ctverce) then begin
      if Body2 > Body1 then CisloHrace := 2;
      if Body1 > Body2 then CisloHrace := 1;
      if CisloHrace = 1 then begin ShowMessage('Vyhrl zelen hr.'); Body := Body1; end
      else begin ShowMessage('Vyhrl erven hr.'); Body := Body2; end;
      AssignFile (f, 't40TopTen.txt');
      if FileExists('t40TopTen.txt') then begin
      
      end
      else begin
         Jmeno := GetJmeno;
         if Jmeno <> '' then begin
            ReWrite(f);
            Writeln(f, Jmeno);
            Writeln(f, Body);
            CloseFile(f);
            foTopTen.ShowModal;
         end;
      end;
      close;
      exit;
   end;

   // zmnm hre
   if not ZabralCtverec then begin
      if CisloHrace = 1 then CisloHrace := 2 else CisloHrace := 1;
      ShowHrac;
   end;
end;


function TfoHra.GetX0: integer;
begin
   Result := self.Left + (self.Width - self.ClientWidth) div 2 + paHra.Left;
end;


function TfoHra.GetY0: integer;
begin
   Result := self.Top + self.Height - (self.Width - self.ClientWidth) div 2 - self.ClientHeight + paHra.Top;
end;


function TfoHra.GetIndexSirky(const x, y: integer): integer;
var i: integer;
begin
   Result := -1;
   for i := 0 to High(Sirky) do
      if (x >= Sirky[i].Left) and
         (x <= Sirky[i].left + Sirky[i].width) and
         (y >= Sirky[i].top) and
         (y <= sirky[i].top + sirky[i].height)
      then Result := i;
end;


procedure TfoHra.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var i: integer;
    PolohaMysi: TPoint;
begin
   if (Key = vk_right) then
      if (IndexSirkyPodMysi < Length(Sirky) div 2) then begin
         if (IndexSirkyPodMysi mod N < N-1) then
            IndexSirkyPodMysi := IndexSirkyPodMysi + 1; end
      else
         if (IndexSirkyPodMysi - Length(Sirky) div 2) mod (N+1) < N then
            IndexSirkyPodMysi := IndexSirkyPodMysi + 1;
   if (Key = vk_left) then
      if (IndexSirkyPodMysi < Length(Sirky) div 2) then begin
         if (IndexSirkyPodMysi mod N > 0) then
            IndexSirkyPodMysi := IndexSirkyPodMysi - 1; end
      else
         if (IndexSirkyPodMysi - Length(Sirky) div 2) mod (N+1) > 0 then
            IndexSirkyPodMysi := IndexSirkyPodMysi - 1;
   if (Key = vk_down) then
      if (IndexSirkyPodMysi < Length(Sirky) div 2) then begin
         i := GetIndexSirky(
            Sirky[IndexSirkyPodMysi].Left - 2,
            Sirky[IndexSirkyPodMysi].Top + RozmerY + 2);
         if i >= 0 then IndexSirkyPodMysi := i;
      end
      else begin
         i := GetIndexSirky(
            Sirky[IndexSirkyPodMysi].Left + RozmerY + 2,
            Sirky[IndexSirkyPodMysi].Top  + RozmerX + 2);
         if i >= 0 then IndexSirkyPodMysi := i
         else begin
            i := GetIndexSirky(
               Sirky[IndexSirkyPodMysi].Left - 2,
               Sirky[IndexSirkyPodMysi].Top  + RozmerX + 2);
            if i >= 0 then IndexSirkyPodMysi := i;
         end;
      end;
   if (Key = vk_up) then
      if (IndexSirkyPodMysi < Length(Sirky) div 2) then begin
         i := GetIndexSirky(
            Sirky[IndexSirkyPodMysi].Left - 2,
            Sirky[IndexSirkyPodMysi].Top - 2);
         if i >= 0 then IndexSirkyPodMysi := i;
      end
      else begin
         i := GetIndexSirky(
            Sirky[IndexSirkyPodMysi].Left + RozmerY + 2,
            Sirky[IndexSirkyPodMysi].Top  - 2);
         if i >= 0 then IndexSirkyPodMysi := i
         else begin
            i := GetIndexSirky(
               Sirky[IndexSirkyPodMysi].Left - 2,
               Sirky[IndexSirkyPodMysi].Top  - 2);
            if i >= 0 then IndexSirkyPodMysi := i;
         end;
      end;

   if Key = ord(' ') then begin
      GetCursorPos(PolohaMysi);
      i := GetIndexSirky(PolohaMysi.x - GetX0, PolohaMysi.y - GetY0);
      if i >= 0 then begin
         SirkaMouseDown(Sirky[i], mbLeft, [], 0, 0);
         IndexSirkyPodMysi := i;
      end;
      Key := 0;
   end;

   if Key in [vk_left, vk_right, vk_down, vk_up] then begin
      Key := 0;
      with Sirky[IndexSirkyPodMysi] do
         SetCursorPos(GetX0 + Left + Width div 2, GetY0 + Top + Height div 2);
   end;
end;

procedure TfoHra.meKonecClick(Sender: TObject);
begin
   Application.Terminate;
end;

procedure TfoHra.meNovaClick(Sender: TObject);
begin
   UkoncitProgram := false;
   Close;
end;

procedure TfoHra.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   if UkoncitProgram then
      Application.Terminate
   else UkoncitProgram := true;
end;

end.
